                    INCLUDE  Map.s
						
	AREA    ISRPROC,CODE,READONLY

SysTickInitialize   PROC
	                EXPORT   SysTickInitialize
					LDR      R0,=STKLOAD
					LDR      R1,=0x000B71B0
					LDR      R2,[R0]
					ORR      R2,R1
					STR      R2,[R0]
;Set SysTick reload value. RELOAD: 0x000B71B0.
					MOV      R1,#0x01
					LDRB     R2,[R0,#-0x04]  ;STKCTRL
					ORR      R2,R1
					STRB     R2,[R0,#-0x04]  ;STKCTRL
;Enable SysTick. ENABLE: 1
					MOV      R1,#0x02
					LDRB     R2,[R0,#-0x04]  ;STKCTRL
					ORR      R2,R1
					STRB     R2,[R0,#-0x04]  ;STKCTRL
;AHB/8, counting down to zero to assert the SysTick exception request.
;CLKSOURCE: 0, TICKINT: 1
                    BX       R14     
					ENDP
SysTickHandler      PROC 
                    EXPORT   SysTickHandler
					IMPORT   LEDControl
                    IMPORT   CoreStatus
					IMPORT   ShowVoltageValue
					IMPORT   ADCStart
					PUSH     {R14}
					MOV      R0,#0xFF
					BL       CoreStatus
;CPU active, change instruction pin status.
					LDR      R1,=0x2000004A
					LDR      R0,[R1]
;Load LED status variable for the specific address.
					CMP      R0,#0x00
;Check current LED status.
                    BLNE     ShowVoltageValue
;Send Voltage value through USART1.
                    CMP      R0,#0x00
;Recheck current LED status.
                    ITET     EQ
                    MOVEQ    R0,#0xFF
					MOVNE    R0,#0x00
					BLEQ     ADCStart
;Start ADC1 converission.
					BL       LEDControl
;Change LED status.
                    STR      R0,[R1]
;Synchronize current LED status to variable.
                    MOV      R0,#0x00
                    BL       CoreStatus
;CPU going to sleep, change instruction pin status.
                    POP      {R15}
;ISR return.
                    ENDP    
	                ALIGN
					END