                    INCLUDE  Map.s
						
	AREA    LEDPROC,CODE,READONLY

IOPortCInitialize   PROC
	                EXPORT   IOPortCInitialize
	                LDR      R0,=GPIOCCRH
					LDR      R1,=0x43244444
					STR      R1,[R0]
;General purpose output push-pull, output mode, max speed 2 MHz.
;General purpose output push-pull, output mode, max speed 50 MHz.
;CNF13: 00, MODE13: 10.
;CNF14: 00, MODE14: 11.
                    BX       R14
					ENDP
LEDControl          PROC
	                EXPORT   LEDControl
					PUSH     {R1-R2,R14}
					MOV      R1,#0x20
					LDR      R2,=GPIOCBSRR
;Load the address of GPIOC Port bit set/reset register.
					CMP      R0,#0x00
;Check next operation: turn ON or turn OFF LED
					ITE      NE
					LSLNE    R1,#0x18
					LSLEQ    R1,#0x08
					STR      R1,[R2]
;Bit set, set PC13 to high level or low level.
                    POP      {R1-R2,R15}
					ENDP
CoreStatus          PROC
	                EXPORT   CoreStatus
	                PUSH     {R1-R2,R14}
					MOV      R1,#0x40
					LDR      R2,=GPIOCBSRR
;Load the address of GPIOC Port bit set/reset register
					CMP      R0,#0x00
					ITE      EQ
					LSLEQ    R1,#0x18
					LSLNE    R1,#0x08
					STR      R1,[R2]
;Bit set, set PC14 to high level or low level.
					POP      {R1-R2,R15}
	                ENDP
					END