GPIOABase         EQU        0x40010800
GPIOBBase         EQU        0x40010C00
GPIOCBase         EQU        0x40011000
GPIODBase         EQU        0x40011400
GPIOEBase         EQU        0x40011800
GPIOFBase         EQU        0x40011C00
GPIOGBase         EQU        0x40012000
;GPIO registers base address
GPIOACRL          EQU        (GPIOABase+0x00)
GPIOACRH          EQU        (GPIOABase+0x04)
GPIOAIDR          EQU        (GPIOABase+0x08)
GPIOAODR          EQU        (GPIOABase+0x0C)
GPIOABSRR         EQU        (GPIOABase+0x10)
GPIOABRR          EQU        (GPIOABase+0x14)
GPIOALCKR         EQU        (GPIOABase+0x18)
;GPIOA registers address
GPIOBCRL          EQU        (GPIOBBase+0x00)
GPIOBCRH          EQU        (GPIOBBase+0x04)
GPIOBIDR          EQU        (GPIOBBase+0x08)
GPIOBODR          EQU        (GPIOBBase+0x0C)
GPIOBBSRR         EQU        (GPIOBBase+0x10)
GPIOBBRR          EQU        (GPIOBBase+0x14)
GPIOBLCKR         EQU        (GPIOBBase+0x18)
;GPIOB registers address
GPIOCCRL          EQU        (GPIOCBase+0x00)
GPIOCCRH          EQU        (GPIOCBase+0x04)
GPIOCIDR          EQU        (GPIOCBase+0x08)
GPIOCODR          EQU        (GPIOCBase+0x0C)
GPIOCBSRR         EQU        (GPIOCBase+0x10)
GPIOCBRR          EQU        (GPIOCBase+0x14)
GPIOCLCKR         EQU        (GPIOCBase+0x18)
;GPIOC registers address
GPIODCRL          EQU        (GPIODBase+0x00)
GPIODCRH          EQU        (GPIODBase+0x04)
GPIODIDR          EQU        (GPIODBase+0x08)
GPIODODR          EQU        (GPIODBase+0x0C)
GPIODBSRR         EQU        (GPIODBase+0x10)
GPIODBRR          EQU        (GPIODBase+0x14)
GPIODLCKR         EQU        (GPIODBase+0x18)
;GPIOD registers address
GPIOECRL          EQU        (GPIOEBase+0x00)
GPIOECRH          EQU        (GPIOEBase+0x04)
GPIOEIDR          EQU        (GPIOEBase+0x08)
GPIOEODR          EQU        (GPIOEBase+0x0C)
GPIOEBSRR         EQU        (GPIOEBase+0x10)
GPIOEBRR          EQU        (GPIOEBase+0x14)
GPIOELCKR         EQU        (GPIOEBase+0x18)
;GPIOE registers address
GPIOFCRL          EQU        (GPIOFBase+0x00)
GPIOFCRH          EQU        (GPIOFBase+0x04)
GPIOFIDR          EQU        (GPIOFBase+0x08)
GPIOFODR          EQU        (GPIOFBase+0x0C)
GPIOFBSRR         EQU        (GPIOFBase+0x10)
GPIOFBRR          EQU        (GPIOFBase+0x14)
GPIOFLCKR         EQU        (GPIOFBase+0x18)
;GPIOF registers address
GPIOGCRL          EQU        (GPIOGBase+0x00)
GPIOGCRH          EQU        (GPIOGBase+0x04)
GPIOGIDR          EQU        (GPIOGBase+0x08)
GPIOGODR          EQU        (GPIOGBase+0x0C)
GPIOGBSRR         EQU        (GPIOGBase+0x10)
GPIOGBRR          EQU        (GPIOGBase+0x14)
GPIOGLCKR         EQU        (GPIOGBase+0x18)
;GPIOG registers address
RCCBase           EQU        0x40021000
;RCC registers base address
RCCCR             EQU        (RCCBase+0x00)
RCCCFGR           EQU        (RCCBase+0x04)
RCCCIR            EQU        (RCCBase+0x08)
RCCAPB2RSTR       EQU        (RCCBase+0x0C)
RCCAPB1RSTR       EQU        (RCCBase+0x10)
RCCAHBENR         EQU        (RCCBase+0x14)
RCCAPB2ENR        EQU        (RCCBase+0x18)
RCCAPB1ENR        EQU        (RCCBase+0x1C)
RCCBDCR           EQU        (RCCBase+0x20)
RCCCSR            EQU        (RCCBase+0x24)
;RCC registers address
AFIOBase          EQU        0x40010000
;AFIO registers base address
AFIOEVCR          EQU        (AFIOBase+0x00)
AFIOMAPR          EQU        (AFIOBase+0x04)
AFIOEXTICR1       EQU        (AFIOBase+0x08)
AFIOEXTICR2       EQU        (AFIOBase+0x0C)
AFIOEXTICR3       EQU        (AFIOBase+0x10)
AFIOEXTICR4       EQU        (AFIOBase+0x14)
AFIOMAPR2         EQU        (AFIOBase+0x1C)
;AFIO registers address
FLASHBase         EQU        0x40022000
;FLASH registers base address
FLASHACR          EQU        (FLASHBase+0x00)
FLASHKEYR         EQU        (FLASHBase+0x04)
FLASHOPTKEYR      EQU        (FLASHBase+0x08)
FLASHSR           EQU        (FLASHBase+0x0C)
FLASHCR           EQU        (FLASHBase+0x10)
FLASHAR           EQU        (FLASHBase+0x14)
FLASHOBR          EQU        (FLASHBase+0x1C)        
FLASHWRPR         EQU        (FLASHBase+0x20)
FLASHKEYR2        EQU        (FLASHBase+0x44)
FLASHSR2          EQU        (FLASHBase+0x4C)
FLASHCR2          EQU        (FLASHBase+0x50)
FLASHAR2          EQU        (FLASHBase+0x54)
;FLASH registers address
FMSCBase          EQU        0xA0000000
;FMSC registers base address
FSMCBCR1          EQU        (FMSCBase+0x0000) 
FSMCBCR2          EQU        (FMSCBase+0x0008)
FSMCBCR3          EQU        (FMSCBase+0x0010)
FSMCBCR4          EQU        (FMSCBase+0x0018)
FSMCBTR1          EQU        (FMSCBase+0x0004)
FSMCBTR2          EQU        (FMSCBase+0x000C)
FSMCBTR3          EQU        (FMSCBase+0x0014)
FSMCBTR4          EQU        (FMSCBase+0x001C)
FSMCBWTR1         EQU        (FMSCBase+0x0104)
FSMCBWTR2         EQU        (FMSCBase+0x010C)
FSMCBWTR3         EQU        (FMSCBase+0x0114)
FSMCBWTR4         EQU        (FMSCBase+0x011C)
FSMCPCR2          EQU        (FMSCBase+0xA0000060)
FSMCPCR3          EQU        (FMSCBase+0xA0000080)
FSMCPCR4          EQU        (FMSCBase+0xA00000A0)
FSMCSR2           EQU        (FMSCBase+0xA0000064)
FSMCSR3           EQU        (FMSCBase+0xA0000084)
FSMCSR4           EQU        (FMSCBase+0xA00000A4)
FSMCPMEM2         EQU        (FMSCBase+0xA0000068)
FSMCPMEM3         EQU        (FMSCBase+0xA0000088)
FSMCPMEM4         EQU        (FMSCBase+0xA00000A8)
FSMCPATT2         EQU        (FMSCBase+0xA000006C)
FSMCPATT3         EQU        (FMSCBase+0xA000008C)
FSMCPATT4         EQU        (FMSCBase+0xA00000AC)
FSMCPIO4          EQU        (FMSCBase+0xA00000B0)
FSMCECCR2         EQU        (FMSCBase+0xA0000074)
FSMCECCR3         EQU        (FMSCBase+0xA0000094)
;FMSC registers address
OTGFSBase         EQU        0x50000000
;USB OTG FS registers base address
OTGFSGOTGCTL      EQU        (OTGFSBase+0x000)
OTGFSGOTGINT      EQU        (OTGFSBase+0x004)
OTGFSGAHBCFG      EQU        (OTGFSBase+0x008)
OTGFSGUSBCFG      EQU        (OTGFSBase+0x00C)
OTGFSGRSTCTL      EQU        (OTGFSBase+0x010)
OTGFSGINTSTS      EQU        (OTGFSBase+0x014)
OTGFSGINTMSK      EQU        (OTGFSBase+0x018)
OTGFSGRXSTSR      EQU        (OTGFSBase+0x01C) 
;0x01C: OTG_FS_GRXSTSR (host mode), OTG_FS_GRXSTSR (Device mode).
;0x020: OTG_FS_GRXSTSR (host mode), OTG_FS_GRXSTSPR (Device mode).
OTGFSGRXSTSPR     EQU        (OTGFSBase+0x020)
OTGFSGRXFSIZ      EQU        (OTGFSBase+0x024)
OTGFSHNPTXFSIZ    EQU        (OTGFSBase+0x028)  ;OTG_FS_DIEPTXF0
OTGFSHNPTXSTS     EQU        (OTGFSBase+0x02C)
OTGFSGCCFG        EQU        (OTGFSBase+0x038)
OTGFSCID          EQU        (OTGFSBase+0x03C)
OTGFSHPTXFSIZ     EQU        (OTGFSBase+0x100)
OTGFSDIEPTXF1     EQU        (OTGFSBase+0x104)
OTGFSDIEPTXF2     EQU        (OTGFSBase+0x108)
OTGFSDIEPTXF3     EQU        (OTGFSBase+0x10C)
OTGFSHCFG         EQU        (OTGFSBase+0x400)
OTGFSHFIR         EQU        (OTGFSBase+0x404)
OTGFSHFNUM        EQU        (OTGFSBase+0x408)
OTGFSHPTXSTS      EQU        (OTGFSBase+0x410)
OTGFSHAINT        EQU        (OTGFSBase+0x414)
OTGFSHAINTMSK     EQU        (OTGFSBase+0x418)
OTGFSHPRT         EQU        (OTGFSBase+0x440)
OTGFSHCCHAR0      EQU        (OTGFSBase+0x500)
OTGFSHCCHAR1      EQU        (OTGFSBase+0x520)
OTGFSHCCHAR2      EQU        (OTGFSBase+0x540)
OTGFSHCCHAR3      EQU        (OTGFSBase+0x560)
OTGFSHCCHAR4      EQU        (OTGFSBase+0x580)
OTGFSHCCHAR5      EQU        (OTGFSBase+0x5A0)
OTGFSHCCHAR6      EQU        (OTGFSBase+0x5C0)
OTGFSHCCHAR7      EQU        (OTGFSBase+0x5E0)
OTGFSHCINT0       EQU        (OTGFSBase+0x508)
OTGFSHCINT1       EQU        (OTGFSBase+0x528)
OTGFSHCINT2       EQU        (OTGFSBase+0x548)
OTGFSHCINT3       EQU        (OTGFSBase+0x568)
OTGFSHCINT4       EQU        (OTGFSBase+0x588)
OTGFSHCINT5       EQU        (OTGFSBase+0x5A8)
OTGFSHCINT6       EQU        (OTGFSBase+0x5C8)
OTGFSHCINT7       EQU        (OTGFSBase+0x5E8)
OTGFSHCINTMSK0    EQU        (OTGFSBase+0x50C)
OTGFSHCINTMSK1    EQU        (OTGFSBase+0x52C)
OTGFSHCINTMSK2    EQU        (OTGFSBase+0x54C)
OTGFSHCINTMSK3    EQU        (OTGFSBase+0x56C)
OTGFSHCINTMSK4    EQU        (OTGFSBase+0x58C)
OTGFSHCINTMSK5    EQU        (OTGFSBase+0x5AC)
OTGFSHCINTMSK6    EQU        (OTGFSBase+0x5CC)
OTGFSHCINTMSK7    EQU        (OTGFSBase+0x5EC)
OTGFSHCTSIZ0      EQU        (OTGFSBase+0x510)
OTGFSHCTSIZ1      EQU        (OTGFSBase+0x530)
OTGFSHCTSIZ2      EQU        (OTGFSBase+0x550)
OTGFSHCTSIZ3      EQU        (OTGFSBase+0x570)
OTGFSHCTSIZ4      EQU        (OTGFSBase+0x590)
OTGFSHCTSIZ5      EQU        (OTGFSBase+0x5B0)
OTGFSHCTSIZ6      EQU        (OTGFSBase+0x5D0)
OTGFSHCTSIZ7      EQU        (OTGFSBase+0x5F0)
OTGFSDCFG         EQU        (OTGFSBase+0x800)
OTGFSDCTL         EQU        (OTGFSBase+0x804)
OTGFSDSTS         EQU        (OTGFSBase+0x808)
OTGFSDIEPMSK      EQU        (OTGFSBase+0x810)
OTGFSDOEPMSK      EQU        (OTGFSBase+0x814)
OTGFSDAINT        EQU        (OTGFSBase+0x818)
OTGFSDAINTMSK     EQU        (OTGFSBase+0x81C)
OTGFSDVBUSDIS     EQU        (OTGFSBase+0x828)
OTGFSDVBUSPULSE   EQU        (OTGFSBase+0x82C)
OTGFSDIEPEMPMSK   EQU        (OTGFSBase+0x834)
OTGFSDIEPCTL0     EQU        (OTGFSBase+0x900)
OTGFSDTXFSTS0     EQU        (OTGFSBase+0x918)
OTGFSDIEPCTL1     EQU        (OTGFSBase+0x920)
OTGFSDTXFSTS1     EQU        (OTGFSBase+0x938)
OTGFSDIEPCTL2     EQU        (OTGFSBase+0x940)
OTGFSDTXFSTS2     EQU        (OTGFSBase+0x958)
OTGFSDIEPCTL3     EQU        (OTGFSBase+0x960)
OTGFSDTXFSTS3     EQU        (OTGFSBase+0x978)
OTGFSDOEPCTL0     EQU        (OTGFSBase+0xB00)
OTGFSDOEPCTL1     EQU        (OTGFSBase+0xB20)
OTGFSDOEPCTL2     EQU        (OTGFSBase+0xB40)
OTGFSDOEPCTL3     EQU        (OTGFSBase+0xB60)
OTGFSDIEPINT0     EQU        (OTGFSBase+0x908)
OTGFSDIEPINT1     EQU        (OTGFSBase+0x928)
OTGFSDIEPINT2     EQU        (OTGFSBase+0x948)
OTGFSDIEPINT3     EQU        (OTGFSBase+0x968)
OTGFSDOEPINT0     EQU        (OTGFSBase+0xB08)
OTGFSDOEPINT1     EQU        (OTGFSBase+0xB28)
OTGFSDOEPINT2     EQU        (OTGFSBase+0xB48)
OTGFSDOEPINT3     EQU        (OTGFSBase+0xB68)
OTGFSDIEPTSIZ0    EQU        (OTGFSBase+0x910)
OTGFSDIEPTSIZ1    EQU        (OTGFSBase+0x930)
OTGFSDIEPTSIZ2    EQU        (OTGFSBase+0x950)
OTGFSDIEPTSIZ3    EQU        (OTGFSBase+0x970)
OTGFSDOEPTSIZ0    EQU        (OTGFSBase+0xB10)
OTGFSDOEPTSIZ1    EQU        (OTGFSBase+0xB30)
OTGFSDOEPTSIZ2    EQU        (OTGFSBase+0xB50)
OTGFSDOEPTSIZ3    EQU        (OTGFSBase+0xB70)
OTGFSPCGCCTL      EQU        (OTGFSBase+0xE00)
;USB OTG FS registers address
EthernetBase      EQU         0x40028000
;Ethernet registers base address
ETHMACCR          EQU        (EthernetBase+0x00)
ETHMACFFR         EQU        (EthernetBase+0x04)
ETHMACHTHR        EQU        (EthernetBase+0x08)
ETHMACHTLR        EQU        (EthernetBase+0x0C)
ETHMACMIIAR       EQU        (EthernetBase+0x10)
ETHMACMIIDR       EQU        (EthernetBase+0x14)
ETHMACFCR         EQU        (EthernetBase+0x18)
ETHMACVLANTR      EQU        (EthernetBase+0x1C)
ETHMACRWUFFR      EQU        (EthernetBase+0x28)
ETHMACPMTCSR      EQU        (EthernetBase+0x2C)
ETHMACSR          EQU        (EthernetBase+0x38)
ETHMACIMR         EQU        (EthernetBase+0x3C)
ETHMACA0HR        EQU        (EthernetBase+0x40)
ETHMACA0LR        EQU        (EthernetBase+0x44)
ETHMACA1HR        EQU        (EthernetBase+0x48)
ETHMACA1LR        EQU        (EthernetBase+0x4C)
ETHMACA2HR        EQU        (EthernetBase+0x50)
ETHMACA2LR        EQU        (EthernetBase+0x54)
ETHMACA3HR        EQU        (EthernetBase+0x58)
ETHMACA3LR        EQU        (EthernetBase+0x5C)
ETHMMCCR          EQU        (EthernetBase+0x100)
ETHMMCRIR         EQU        (EthernetBase+0x104)
ETHMMCTIR         EQU        (EthernetBase+0x108)
ETHMMCRIMR        EQU        (EthernetBase+0x10C)
ETHMMCTIMR        EQU        (EthernetBase+0x110)
ETHMMCTGFSCCR     EQU        (EthernetBase+0x14C)
ETHMMCTGFMSCCR    EQU        (EthernetBase+0x150)
ETHMMCTGFCR       EQU        (EthernetBase+0x168)
ETHMMCRFCECR      EQU        (EthernetBase+0x194)
ETHMMCRFAECR      EQU        (EthernetBase+0x198)
ETHMMCRGUFCR      EQU        (EthernetBase+0x1C4)
ETHPTPTSCR        EQU        (EthernetBase+0x700)
ETHPTPSSIR        EQU        (EthernetBase+0x704)
ETHPTPTSHR        EQU        (EthernetBase+0x708)
ETHPTPTSLR        EQU        (EthernetBase+0x70C)
ETHPTPTSHUR       EQU        (EthernetBase+0x710)
ETHPTPTSLUR       EQU        (EthernetBase+0x714)
;Ethernet registers address
CRCBase           EQU        0x40023000
;CRC registers base address
CRCDR             EQU        (CRCBase+0x00)
CRCIDR            EQU        (CRCBase+0x04)
CRCCR             EQU        (CRCBase+0x08)
;CRC registers address
DMA1Base          EQU        0x40020000
DMA2Base          EQU        0x40020400
;DMA registers base address
DMA1ISR           EQU        (DMA1Base+0x000)
DMA1IFCR          EQU        (DMA1Base+0x004)
DMA1CCR1          EQU        (DMA1Base+0x008)
DMA1CNDTR1        EQU        (DMA1Base+0x00C)
DMA1CPAR1         EQU        (DMA1Base+0x010)
DMA1CMAR1         EQU        (DMA1Base+0x014)
DMA1CCR2          EQU        (DMA1Base+0x01C)
DMA1CNDTR2        EQU        (DMA1Base+0x020)
DMA1CPAR2         EQU        (DMA1Base+0x024) 
DMA1CMAR2         EQU        (DMA1Base+0x028)
DMA1CCR3          EQU        (DMA1Base+0x030)
DMA1CNDTR3        EQU        (DMA1Base+0x034)
DMA1CPAR3         EQU        (DMA1Base+0x038)
DMA1CMAR3         EQU        (DMA1Base+0x03C)
DMA1CCR4          EQU        (DMA1Base+0x044)		
DMA1CNDTR4        EQU        (DMA1Base+0x048)		
DMA1CPAR4         EQU        (DMA1Base+0x04C)		
DMA1CMAR4         EQU        (DMA1Base+0x050)		
DMA1CCR5          EQU        (DMA1Base+0x058)		
DMA1CNDTR5        EQU        (DMA1Base+0x05C)		
DMA1CPAR5         EQU        (DMA1Base+0x060)		
DMA1CMAR5         EQU        (DMA1Base+0x064)		
DMA1CCR6          EQU        (DMA1Base+0x06C)		
DMA1CNDTR6        EQU        (DMA1Base+0x070)		
DMA1CPAR6         EQU        (DMA1Base+0x074)		
DMA1CMAR6         EQU        (DMA1Base+0x078)		
DMA1CCR7          EQU        (DMA1Base+0x080)		
DMA1CNDTR7        EQU        (DMA1Base+0x084)
DMA1CPAR7         EQU        (DMA1Base+0x088)
DMA1CMAR7         EQU        (DMA1Base+0x08C)			  
;DMA1 registers address
DMA2ISR           EQU        (DMA2Base+0x000)
DMA2IFCR          EQU        (DMA2Base+0x004)
DMA2CCR1          EQU        (DMA2Base+0x008)
DMA2CNDTR1        EQU        (DMA2Base+0x00C)
DMA2CPAR1         EQU        (DMA2Base+0x010)
DMA2CMAR1         EQU        (DMA2Base+0x014)
DMA2CCR2          EQU        (DMA2Base+0x01C)
DMA2CNDTR2        EQU        (DMA2Base+0x020)
DMA2CPAR2         EQU        (DMA2Base+0x024) 
DMA2CMAR2         EQU        (DMA2Base+0x028)
DMA2CCR3          EQU        (DMA2Base+0x030)
DMA2CNDTR3        EQU        (DMA2Base+0x034)
DMA2CPAR3         EQU        (DMA2Base+0x038)
DMA2CMAR3         EQU        (DMA2Base+0x03C)
DMA2CCR4          EQU        (DMA2Base+0x044)		
DMA2CNDTR4        EQU        (DMA2Base+0x048)		
DMA2CPAR4         EQU        (DMA2Base+0x04C)		
DMA2CMAR4         EQU        (DMA2Base+0x050)		
DMA2CCR5          EQU        (DMA2Base+0x058)		
DMA2CNDTR5        EQU        (DMA2Base+0x05C)		
DMA2CPAR5         EQU        (DMA2Base+0x060)		
DMA2CMAR5         EQU        (DMA2Base+0x064)		
DMA2CCR6          EQU        (DMA2Base+0x06C)		
DMA2CNDTR6        EQU        (DMA2Base+0x070)		
DMA2CPAR6         EQU        (DMA2Base+0x074)		
DMA2CMAR6         EQU        (DMA2Base+0x078)		
DMA2CCR7          EQU        (DMA2Base+0x080)		
DMA2CNDTR7        EQU        (DMA2Base+0x084)
DMA2CPAR7         EQU        (DMA2Base+0x088)
DMA2CMAR7         EQU        (DMA2Base+0x08C)
;DMA2 registers address
SDIOBase          EQU        0x40018000
;SDIO registers base address
SDIOPOWER         EQU        (SDIOBase+0x00)
SDIOCLKCR	      EQU        (SDIOBase+0x04)
SDIOARG           EQU        (SDIOBase+0x08)
SDIOCMD           EQU        (SDIOBase+0x0C)
SDIORESPCMD       EQU        (SDIOBase+0x10)
SDIORESP1         EQU        (SDIOBase+0x14)
SDIORESP2         EQU        (SDIOBase+0x18)
SDIORESP3         EQU        (SDIOBase+0x1C)
SDIORESP4         EQU        (SDIOBase+0x20)
SDIODTIMER        EQU        (SDIOBase+0x24)
SDIODLEN          EQU        (SDIOBase+0x28)
SDIODCTRL         EQU        (SDIOBase+0x2C)
SDIODCOUNT        EQU        (SDIOBase+0x30)
SDIOSTA           EQU        (SDIOBase+0x34)
SDIOICR           EQU        (SDIOBase+0x38)
SDIOMASK          EQU        (SDIOBase+0x3C)
SDIOFIFOCNT       EQU        (SDIOBase+0x48)
SDIOFIFO          EQU        (SDIOBase+0x80)
;SDIO registers address
SPI1Base          EQU        0x40013000
SPI2Base          EQU        0x40003800
SPI3Base          EQU        0x40003C00
;SPI registers base address
SPI1CR1           EQU        (SPI1Base+0x00)
SPI1CR2           EQU        (SPI1Base+0x04)
SPI1SR            EQU        (SPI1Base+0x08)
SPI1DR            EQU        (SPI1Base+0x0C)
SPI1CRCPR         EQU        (SPI1Base+0x10)
SPI1RXCRCR        EQU        (SPI1Base+0x14)
SPI1TXCRCR        EQU        (SPI1Base+0x18)
;SPI1 registers address
SPI2CR1           EQU        (SPI2Base+0x00)
SPI2CR2           EQU        (SPI2Base+0x04)
SPI2SR            EQU        (SPI2Base+0x08)
SPI2DR            EQU        (SPI2Base+0x0C)
SPI2CRCPR         EQU        (SPI2Base+0x10)
SPI2RXCRCR        EQU        (SPI2Base+0x14)
SPI2TXCRCR        EQU        (SPI2Base+0x18)
SPI2I2SCFGR       EQU        (SPI2Base+0x1C)
SPI2I2SPR         EQU        (SPI2Base+0x20)
;SPI2 registers address
SPI3CR1           EQU        (SPI3Base+0x00)
SPI3CR2           EQU        (SPI3Base+0x04)
SPI3SR            EQU        (SPI3Base+0x08)
SPI3DR            EQU        (SPI3Base+0x0C)
SPI3CRCPR         EQU        (SPI3Base+0x10)
SPI3RXCRCR        EQU        (SPI3Base+0x14)
SPI3TXCRCR        EQU        (SPI3Base+0x18)
SPI3I2SCFGR       EQU        (SPI3Base+0x1C)
SPI3I2SPR         EQU        (SPI3Base+0x20)
;SPI3 registers address
TIM1Base          EQU        0x40012C00
TIM2Base          EQU        0x40000000
TIM3Base          EQU        0x40000400
TIM4Base          EQU        0x40000800
TIM5Base          EQU        0x40000C00
TIM6Base          EQU        0x40001000
TIM7Base          EQU        0x40001400
TIM8Base          EQU        0x40013400
TIM9Base          EQU        0x40014C00
TIM10Base         EQU        0x40015000
TIM11Base         EQU        0x40015400
TIM12Base         EQU        0x40001800
TIM13Base         EQU        0x40001C00
TIM14Base         EQU        0x40002000
;Timer registers base address
TIM1CR1           EQU        (TIM1Base+0x00)
TIM1CR2           EQU        (TIM1Base+0x04)
TIM1SMCR          EQU        (TIM1Base+0x08)
TIM1DIER          EQU        (TIM1Base+0x0C)
TIM1SR            EQU        (TIM1Base+0x10)
TIM1EGR           EQU        (TIM1Base+0x14)
TIM1CCMR1         EQU        (TIM1Base+0x18)
TIM1CCMR2         EQU        (TIM1Base+0x1C)
TIM1CCER          EQU        (TIM1Base+0x20)
TIM1CNT           EQU        (TIM1Base+0x24)
TIM1PSC           EQU        (TIM1Base+0x28)
TIM1ARR           EQU        (TIM1Base+0x2C)
TIM1RCR           EQU        (TIM1Base+0x30)
TIM1CCR1          EQU        (TIM1Base+0x34)
TIM1CCR2          EQU        (TIM1Base+0x38)
TIM1CCR3          EQU        (TIM1Base+0x3C)
TIM1CCR4          EQU        (TIM1Base+0x40)
TIM1BDTR          EQU        (TIM1Base+0x44)
TIM1DCR           EQU        (TIM1Base+0x48)
TIM1DMAR          EQU        (TIM1Base+0x4C)
;TIM1 timer registers address
TIM8CR1           EQU        (TIM8Base+0x00)
TIM8CR2           EQU        (TIM8Base+0x04)
TIM8SMCR          EQU        (TIM8Base+0x08)
TIM8DIER          EQU        (TIM8Base+0x0C)
TIM8SR            EQU        (TIM8Base+0x10)
TIM8EGR           EQU        (TIM8Base+0x14)
TIM8CCMR1         EQU        (TIM8Base+0x18)
TIM8CCMR2         EQU        (TIM8Base+0x1C)
TIM8CCER          EQU        (TIM8Base+0x20)
TIM8CNT           EQU        (TIM8Base+0x24)
TIM8PSC           EQU        (TIM8Base+0x28)
TIM8ARR           EQU        (TIM8Base+0x2C)
TIM8RCR           EQU        (TIM8Base+0x30)
TIM8CCR1          EQU        (TIM8Base+0x34)
TIM8CCR2          EQU        (TIM8Base+0x38)
TIM8CCR3          EQU        (TIM8Base+0x3C)
TIM8CCR4          EQU        (TIM8Base+0x40)
TIM8BDTR          EQU        (TIM8Base+0x44)
TIM8DCR           EQU        (TIM8Base+0x48)
TIM8DMAR          EQU        (TIM8Base+0x4C)
;TIM8 timer registers address
TIM10CR1          EQU        (TIM10Base+0x00)
TIM10SMCR         EQU        (TIM10Base+0x08)
TIM10DIER         EQU        (TIM10Base+0x0C)
TIM10SR           EQU        (TIM10Base+0x10)
TIM10EGR          EQU        (TIM10Base+0x14)
TIM10CCMR1        EQU        (TIM10Base+0x18)
TIM10CCER         EQU        (TIM10Base+0x20)
TIM10CNT          EQU        (TIM10Base+0x24)
TIM10PSC          EQU        (TIM10Base+0x28)
TIM10ARR          EQU        (TIM10Base+0x2C)
TIM10CCR1         EQU        (TIM10Base+0x34)
;TIM10 timer registers address
TIM11CR1          EQU        (TIM11Base+0x00)
TIM11SMCR         EQU        (TIM11Base+0x08)
TIM11DIER         EQU        (TIM11Base+0x0C)
TIM11SR           EQU        (TIM11Base+0x10)
TIM11EGR          EQU        (TIM11Base+0x14)
TIM11CCMR1        EQU        (TIM11Base+0x18)
TIM11CCER         EQU        (TIM11Base+0x20)
TIM11CNT          EQU        (TIM11Base+0x24)
TIM11PSC          EQU        (TIM11Base+0x28)
TIM11ARR          EQU        (TIM11Base+0x2C)
TIM11CCR1         EQU        (TIM11Base+0x34)
;TIM11 timer registers address
TIM13CR1          EQU        (TIM13Base+0x00)
TIM13SMCR         EQU        (TIM13Base+0x08)
TIM13DIER         EQU        (TIM13Base+0x0C)
TIM13SR           EQU        (TIM13Base+0x10)
TIM13EGR          EQU        (TIM13Base+0x14)
TIM13CCMR1        EQU        (TIM13Base+0x18)
TIM13CCER         EQU        (TIM13Base+0x20)
TIM13CNT          EQU        (TIM13Base+0x24)
TIM13PSC          EQU        (TIM13Base+0x28)
TIM13ARR          EQU        (TIM13Base+0x2C)
TIM13CCR1         EQU        (TIM13Base+0x34)
;TIM13 timer registers address
TIM14CR1          EQU        (TIM14Base+0x00)
TIM14SMCR         EQU        (TIM14Base+0x08)
TIM14DIER         EQU        (TIM14Base+0x0C)
TIM14SR           EQU        (TIM14Base+0x10)
TIM14EGR          EQU        (TIM14Base+0x14)
TIM14CCMR1        EQU        (TIM14Base+0x18)
TIM14CCER         EQU        (TIM14Base+0x20)
TIM14CNT          EQU        (TIM14Base+0x24)
TIM14PSC          EQU        (TIM14Base+0x28)
TIM14ARR          EQU        (TIM14Base+0x2C)
TIM14CCR1         EQU        (TIM14Base+0x34)
;TIM14 timer registers address
TIM6CR1           EQU        (TIM6Base+0x00)
TIM6CR2           EQU        (TIM6Base+0x04)
TIM6DIER          EQU        (TIM6Base+0x0C)
TIM6SR            EQU        (TIM6Base+0x10)
TIM6EGR           EQU        (TIM6Base+0x14)
TIM6CNT           EQU        (TIM6Base+0x24)
TIM6PSC           EQU        (TIM6Base+0x28)
TIM6ARR           EQU        (TIM6Base+0x2C)
;TIM6 timer registers address
TIM7CR1           EQU        (TIM7Base+0x00)
TIM7CR2           EQU        (TIM7Base+0x04)
TIM7DIER          EQU        (TIM7Base+0x0C)
TIM7SR            EQU        (TIM7Base+0x10)
TIM7EGR           EQU        (TIM7Base+0x14)
TIM7CNT           EQU        (TIM7Base+0x24)
TIM7PSC           EQU        (TIM7Base+0x28)
TIM7ARR           EQU        (TIM7Base+0x2C)
;TIM7 timer registers address
TIM9CR1           EQU        (TIM9Base+0x00)
TIM9SMCR	      EQU        (TIM9Base+0x08)
TIM9DIER          EQU        (TIM9Base+0x0C)
TIM9SR     	      EQU        (TIM9Base+0x10)
TIM9EGR           EQU        (TIM9Base+0x14)
TIM9CCMR1    	  EQU        (TIM9Base+0x18)
TIM9CCER          EQU        (TIM9Base+0x20)
TIM9CNT           EQU        (TIM9Base+0x24)
TIM9PSC           EQU        (TIM9Base+0x28)
TIM9ARR   	      EQU        (TIM9Base+0x2C)
TIM9CCR1          EQU        (TIM9Base+0x34)
TIM9CCR2          EQU        (TIM9Base+0x38)
;TIM9 timer registers address
TIM12CR1          EQU        (TIM12Base+0x00)
TIM12SMCR	      EQU        (TIM12Base+0x08)
TIM12DIER         EQU        (TIM12Base+0x0C)
TIM12SR           EQU        (TIM12Base+0x10)
TIM12EGR          EQU        (TIM12Base+0x14)
TIM12CCMR1        EQU        (TIM12Base+0x18)
TIM12CCER         EQU        (TIM12Base+0x20)
TIM12CNT          EQU        (TIM12Base+0x24)
TIM12PSC          EQU        (TIM12Base+0x28)
TIM12ARR          EQU        (TIM12Base+0x2C)
TIM12CCR1         EQU        (TIM12Base+0x34)
TIM12CCR2         EQU        (TIM12Base+0x38)
;TIM12 timer registers address
TIM2CR1           EQU        (TIM2Base+0x00)
TIM2CR2           EQU        (TIM2Base+0x04)
TIM2SMCR          EQU        (TIM2Base+0x08)
TIM2DIER          EQU        (TIM2Base+0x0C)
TIM2SR            EQU        (TIM2Base+0x10)
TIM2EGR           EQU        (TIM2Base+0x14)
TIM2CCMR1         EQU        (TIM2Base+0x18)
TIM2CCMR2         EQU        (TIM2Base+0x1C)
TIM2CCER          EQU        (TIM2Base+0x20)
TIM2CNT           EQU        (TIM2Base+0x24)
TIM2PSC           EQU        (TIM2Base+0x28)
TIM2ARR           EQU        (TIM2Base+0x2C)
TIM2CCR1          EQU        (TIM2Base+0x34)
TIM2CCR2          EQU        (TIM2Base+0x38)
TIM2CCR3          EQU        (TIM2Base+0x3C)
TIM2CCR4	      EQU        (TIM2Base+0x40)
TIM2DCR	          EQU        (TIM2Base+0x48)
TIM2DMAR          EQU        (TIM2Base+0x4C)
;TIM2 timer registers address
TIM3CR1           EQU        (TIM3Base+0x00)
TIM3CR2           EQU        (TIM3Base+0x04)
TIM3SMCR          EQU        (TIM3Base+0x08)
TIM3DIER          EQU        (TIM3Base+0x0C)
TIM3SR            EQU        (TIM3Base+0x10)
TIM3EGR           EQU        (TIM3Base+0x14)
TIM3CCMR1         EQU        (TIM3Base+0x18)
TIM3CCMR2         EQU        (TIM3Base+0x1C)
TIM3CCER          EQU        (TIM3Base+0x20)
TIM3CNT           EQU        (TIM3Base+0x24)
TIM3PSC           EQU        (TIM3Base+0x28)
TIM3ARR           EQU        (TIM3Base+0x2C)
TIM3CCR1          EQU        (TIM3Base+0x34)
TIM3CCR2          EQU        (TIM3Base+0x38)
TIM3CCR3          EQU        (TIM3Base+0x3C)
TIM3CCR4	      EQU        (TIM3Base+0x40)
TIM3DCR	          EQU        (TIM3Base+0x48)
TIM3DMAR          EQU        (TIM3Base+0x4C)
;TIM3 timer registers address
TIM4CR1           EQU        (TIM4Base+0x00)
TIM4CR2           EQU        (TIM4Base+0x04)
TIM4SMCR          EQU        (TIM4Base+0x08)
TIM4DIER          EQU        (TIM4Base+0x0C)
TIM4SR            EQU        (TIM4Base+0x10)
TIM4EGR           EQU        (TIM4Base+0x14)
TIM4CCMR1         EQU        (TIM4Base+0x18)
TIM4CCMR2         EQU        (TIM4Base+0x1C)
TIM4CCER          EQU        (TIM4Base+0x20)
TIM4CNT           EQU        (TIM4Base+0x24)
TIM4PSC           EQU        (TIM4Base+0x28)
TIM4ARR           EQU        (TIM4Base+0x2C)
TIM4CCR1          EQU        (TIM4Base+0x34)
TIM4CCR2          EQU        (TIM4Base+0x38)
TIM4CCR3          EQU        (TIM4Base+0x3C)
TIM4CCR4	      EQU        (TIM4Base+0x40)
TIM4DCR	          EQU        (TIM4Base+0x48)
TIM4DMAR          EQU        (TIM4Base+0x4C)
;TIM4 timer registers address
TIM5CR1           EQU        (TIM5Base+0x00)
TIM5CR2           EQU        (TIM5Base+0x04)
TIM5SMCR          EQU        (TIM5Base+0x08)
TIM5DIER          EQU        (TIM5Base+0x0C)
TIM5SR            EQU        (TIM5Base+0x10)
TIM5EGR           EQU        (TIM5Base+0x14)
TIM5CCMR1         EQU        (TIM5Base+0x18)
TIM5CCMR2         EQU        (TIM5Base+0x1C)
TIM5CCER          EQU        (TIM5Base+0x20)
TIM5CNT           EQU        (TIM5Base+0x24)
TIM5PSC           EQU        (TIM5Base+0x28)
TIM5ARR           EQU        (TIM5Base+0x2C)
TIM5CCR1          EQU        (TIM5Base+0x34)
TIM5CCR2          EQU        (TIM5Base+0x38)
TIM5CCR3          EQU        (TIM5Base+0x3C)
TIM5CCR4	      EQU        (TIM5Base+0x40)
TIM5DCR	          EQU        (TIM5Base+0x48)
TIM5DMAR          EQU        (TIM5Base+0x4C)
;TIM5 timer registers address
PWRBase           EQU        0x40007000
;Power control registers base address
PWRCR             EQU        (PWRBase+0x000)
PWRCSR            EQU        (PWRBase+0x004)
;Power control registers address
BKPBase           EQU        0x40006C00
;Backup registers base address
BKPDR1            EQU        (BKPBase+0x04)
BKPDR2            EQU        (BKPBase+0x08)
BKPDR3            EQU        (BKPBase+0x0C)
BKPDR4            EQU        (BKPBase+0x10)
BKPDR5            EQU        (BKPBase+0x14)
BKPDR6            EQU        (BKPBase+0x18)
BKPDR7            EQU        (BKPBase+0x1C)
BKPDR8            EQU        (BKPBase+0x20)
BKPDR9            EQU        (BKPBase+0x24)
BKPDR10           EQU        (BKPBase+0x28)
BKPRTCCR          EQU        (BKPBase+0x2C)
BKPCR             EQU        (BKPBase+0x30)
BKPCSR            EQU        (BKPBase+0x34)
BKPDR11           EQU        (BKPBase+0x40)
BKPDR12           EQU        (BKPBase+0x44)
BKPDR13           EQU        (BKPBase+0x48)
BKPDR14           EQU        (BKPBase+0x4C)
BKPDR15           EQU        (BKPBase+0x50)
BKPDR16           EQU        (BKPBase+0x54)
BKPDR17           EQU        (BKPBase+0x58)
BKPDR18           EQU        (BKPBase+0x5C)
BKPDR19           EQU        (BKPBase+0x60)
BKPDR20           EQU        (BKPBase+0x64)
BKPDR21           EQU        (BKPBase+0x68)
BKPDR22           EQU        (BKPBase+0x6C)
BKPDR23           EQU        (BKPBase+0x70)
BKPDR24           EQU        (BKPBase+0x74)
BKPDR25           EQU        (BKPBase+0x78)
BKPDR26           EQU        (BKPBase+0x7C)
BKPDR27           EQU        (BKPBase+0x80)
BKPDR28           EQU        (BKPBase+0x84)
BKPDR29           EQU        (BKPBase+0x88)
BKPDR30           EQU        (BKPBase+0x8C)
BKPDR31           EQU        (BKPBase+0x90)
BKPDR32           EQU        (BKPBase+0x94)
BKPDR33           EQU        (BKPBase+0x98)
BKPDR34           EQU        (BKPBase+0x9C)
BKPDR35           EQU        (BKPBase+0xA0)
BKPDR36           EQU        (BKPBase+0xA4)
BKPDR37           EQU        (BKPBase+0xA8)
BKPDR38           EQU        (BKPBase+0xAC)
BKPDR39           EQU        (BKPBase+0xB0)
BKPDR40           EQU        (BKPBase+0xB4)
BKPDR41           EQU        (BKPBase+0xB8)
BKPDR42           EQU        (BKPBase+0xBC)
;Backup registers address
bxCAN1Base        EQU        0x40006400
bxCAN2Base        EQU        0x40006800
;bxCAN registers base address
CAN1MCR           EQU        (bxCAN1Base+0x000)
CAN1MSR		      EQU        (bxCAN1Base+0x004)
CAN1TSR           EQU        (bxCAN1Base+0x008)
CAN1RF0R          EQU        (bxCAN1Base+0x00C)
CAN1RF1R          EQU        (bxCAN1Base+0x010)
CAN1IER	      	  EQU        (bxCAN1Base+0x014)
CAN1ESR           EQU        (bxCAN1Base+0x018)
CAN1BTR           EQU        (bxCAN1Base+0x01C)
CAN1TI0R          EQU        (bxCAN1Base+0x180)
CAN1TDT0R	   	  EQU        (bxCAN1Base+0x184)
CAN1TDL0R         EQU        (bxCAN1Base+0x188)
CAN1TDH0R         EQU        (bxCAN1Base+0x18C)
CAN1TI1R          EQU        (bxCAN1Base+0x190)
CAN1TDT1R	      EQU        (bxCAN1Base+0x194)
CAN1TDL1R         EQU        (bxCAN1Base+0x198)
CAN1TDH1R         EQU        (bxCAN1Base+0x19C)
CAN1TI2R          EQU        (bxCAN1Base+0x1A0)
CAN1TDT2R	      EQU        (bxCAN1Base+0x1A4)
CAN1TDL2R         EQU        (bxCAN1Base+0x1A8)
CAN1TDH2R         EQU        (bxCAN1Base+0x1AC)
CAN1RI0R          EQU        (bxCAN1Base+0x1B0)
CAN1RDT0R	      EQU        (bxCAN1Base+0x1B4)
CAN1RDL0R         EQU        (bxCAN1Base+0x1B8)
CAN1RDH0R         EQU        (bxCAN1Base+0x1BC)
CAN1RI1R          EQU        (bxCAN1Base+0x1C0)
CAN1RDT1R   	  EQU        (bxCAN1Base+0x1C4)
CAN1RDL1R         EQU        (bxCAN1Base+0x1C8)
CAN1RDH1R         EQU        (bxCAN1Base+0x1CC)
CAN1FMR           EQU        (bxCAN1Base+0x200)
CAN1FM1R	      EQU        (bxCAN1Base+0x204)
CAN1FS1R          EQU        (bxCAN1Base+0x20C)
CAN1FFA1R         EQU        (bxCAN1Base+0x214)
CAN1FA1R          EQU        (bxCAN1Base+0x21C)
CAN1F0R1          EQU        (bxCAN1Base+0x240)
CAN1F0R2          EQU        (bxCAN1Base+0x244)
CAN1F1R1          EQU        (bxCAN1Base+0x248)
CAN1F1R2          EQU        (bxCAN1Base+0x24C)
CAN1F2R1          EQU        (bxCAN1Base+0x250)
CAN1F2R2          EQU        (bxCAN1Base+0x254)
CAN1F3R1          EQU        (bxCAN1Base+0x258)
CAN1F3R2          EQU        (bxCAN1Base+0x25C)
CAN1F4R1          EQU        (bxCAN1Base+0x260)
CAN1F4R2          EQU        (bxCAN1Base+0x264)
CAN1F5R1          EQU        (bxCAN1Base+0x268)
CAN1F5R2          EQU        (bxCAN1Base+0x26C)
CAN1F6R1          EQU        (bxCAN1Base+0x270)
CAN1F6R2          EQU        (bxCAN1Base+0x274)
CAN1F7R1          EQU        (bxCAN1Base+0x278)
CAN1F7R2          EQU        (bxCAN1Base+0x27C)
CAN1F8R1          EQU        (bxCAN1Base+0x280)
CAN1F8R2          EQU        (bxCAN1Base+0x284)
CAN1F9R1          EQU        (bxCAN1Base+0x288)
CAN1F9R2          EQU        (bxCAN1Base+0x28C)
CAN1F10R1         EQU        (bxCAN1Base+0x290)
CAN1F10R2         EQU        (bxCAN1Base+0x294)
CAN1F11R1         EQU        (bxCAN1Base+0x298)
CAN1F11R2         EQU        (bxCAN1Base+0x29C)
CAN1F12R1         EQU        (bxCAN1Base+0x2A0)
CAN1F12R2         EQU        (bxCAN1Base+0x2A4)
CAN1F13R1         EQU        (bxCAN1Base+0x2A8)
CAN1F13R2         EQU        (bxCAN1Base+0x2AC)		
;bxCAN1 registers address
CAN2MCR           EQU        (bxCAN2Base+0x000)
CAN2MSR		      EQU        (bxCAN2Base+0x004)
CAN2TSR           EQU        (bxCAN2Base+0x008)
CAN2RF0R          EQU        (bxCAN2Base+0x00C)
CAN2RF1R          EQU        (bxCAN2Base+0x010)
CAN2IER	      	  EQU        (bxCAN2Base+0x014)
CAN2ESR           EQU        (bxCAN2Base+0x018)
CAN2BTR           EQU        (bxCAN2Base+0x01C)
CAN2TI0R          EQU        (bxCAN2Base+0x180)
CAN2TDT0R	   	  EQU        (bxCAN2Base+0x184)
CAN2TDL0R         EQU        (bxCAN2Base+0x188)
CAN2TDH0R         EQU        (bxCAN2Base+0x18C)
CAN2TI1R          EQU        (bxCAN2Base+0x190)
CAN2TDT1R	      EQU        (bxCAN2Base+0x194)
CAN2TDL1R         EQU        (bxCAN2Base+0x198)
CAN2TDH1R         EQU        (bxCAN2Base+0x19C)
CAN2TI2R          EQU        (bxCAN2Base+0x1A0)
CAN2TDT2R	      EQU        (bxCAN2Base+0x1A4)
CAN2TDL2R         EQU        (bxCAN2Base+0x1A8)
CAN2TDH2R         EQU        (bxCAN2Base+0x1AC)
CAN2RI0R          EQU        (bxCAN2Base+0x1B0)
CAN2RDT0R	   	  EQU        (bxCAN2Base+0x1B4)
CAN2RDL0R         EQU        (bxCAN2Base+0x1B8)
CAN2RDH0R         EQU        (bxCAN2Base+0x1BC)
CAN2RI1R          EQU        (bxCAN2Base+0x1C0)
CAN2RDT1R		  EQU        (bxCAN2Base+0x1C4)
CAN2RDL1R         EQU        (bxCAN2Base+0x1C8)
CAN2RDH1R         EQU        (bxCAN2Base+0x1CC)
CAN2FMR           EQU        (bxCAN2Base+0x200)
CAN2FM1R	      EQU        (bxCAN2Base+0x204)
CAN2FS1R          EQU        (bxCAN2Base+0x20C)
CAN2FFA1R         EQU        (bxCAN2Base+0x214)
CAN2FA1R          EQU        (bxCAN2Base+0x21C)
CAN2F0R1          EQU        (bxCAN2Base+0x240)
CAN2F0R2          EQU        (bxCAN2Base+0x244)
CAN2F1R1          EQU        (bxCAN2Base+0x248)
CAN2F1R2          EQU        (bxCAN2Base+0x24C)
CAN2F2R1          EQU        (bxCAN2Base+0x250)
CAN2F2R2          EQU        (bxCAN2Base+0x254)
CAN2F3R1          EQU        (bxCAN2Base+0x258)
CAN2F3R2          EQU        (bxCAN2Base+0x25C)
CAN2F4R1          EQU        (bxCAN2Base+0x260)
CAN2F4R2          EQU        (bxCAN2Base+0x264)
CAN2F5R1          EQU        (bxCAN2Base+0x268)
CAN2F5R2          EQU        (bxCAN2Base+0x26C)
CAN2F6R1          EQU        (bxCAN2Base+0x270)
CAN2F6R2          EQU        (bxCAN2Base+0x274)
CAN2F7R1          EQU        (bxCAN2Base+0x278)
CAN2F7R2          EQU        (bxCAN2Base+0x27C)
CAN2F8R1          EQU        (bxCAN2Base+0x280)
CAN2F8R2          EQU        (bxCAN2Base+0x284)
CAN2F9R1          EQU        (bxCAN2Base+0x288)
CAN2F9R2          EQU        (bxCAN2Base+0x28C)
CAN2F10R1         EQU        (bxCAN2Base+0x290)
CAN2F10R2         EQU        (bxCAN2Base+0x294)
CAN2F11R1         EQU        (bxCAN2Base+0x298)
CAN2F11R2         EQU        (bxCAN2Base+0x29C)
CAN2F12R1         EQU        (bxCAN2Base+0x2A0)
CAN2F12R2         EQU        (bxCAN2Base+0x2A4)
CAN2F13R1         EQU        (bxCAN2Base+0x2A8)
CAN2F13R2         EQU        (bxCAN2Base+0x2AC)		
;bxCAN2 registers address
USBBase           EQU        0x40005C00
;USB device FS registers base address
USBEP0R           EQU        (USBBase+0x00)
USBEP1R           EQU        (USBBase+0x04)
USBEP2R           EQU        (USBBase+0x08)
USBEP3R           EQU        (USBBase+0x0C)
USBEP4R           EQU        (USBBase+0x10)
USBEP5R           EQU        (USBBase+0x14)
USBEP6R           EQU        (USBBase+0x18)
USBEP7R           EQU        (USBBase+0x1C)
USBCNTR           EQU        (USBBase+0x40)
USBISTR           EQU        (USBBase+0x44)
USBFNR            EQU        (USBBase+0x48)
USBDADDR          EQU        (USBBase+0x4C)
USBBTABLE         EQU        (USBBase+0x50)
;USB device FS address
I2C1Base          EQU        0x40005400
I2C2Base          EQU        0x40005800
;IIC registers base address
I2C1CR1           EQU        (I2C1Base+0x00)
I2C1CR2	          EQU        (I2C1Base+0x04)
I2C1OAR1	      EQU        (I2C1Base+0x08)
I2C1OAR2          EQU        (I2C1Base+0x0C)
I2C1DR      	  EQU        (I2C1Base+0x10)
I2C1SR1     	  EQU        (I2C1Base+0x14)
I2C1SR2           EQU        (I2C1Base+0x18)
I2C1CCR     	  EQU        (I2C1Base+0x1C)
I2C1TRISE	      EQU        (I2C1Base+0x20)
;IIC1 registers address
I2C2CR1           EQU        (I2C2Base+0x00)
I2C2CR2	          EQU        (I2C2Base+0x04)
I2C2OAR1	      EQU        (I2C2Base+0x08)
I2C2OAR2          EQU        (I2C2Base+0x0C)
I2C2DR      	  EQU        (I2C2Base+0x10)
I2C2SR1     	  EQU        (I2C2Base+0x14)
I2C2SR2           EQU        (I2C2Base+0x18)
I2C2CCR     	  EQU        (I2C2Base+0x1C)
I2C2TRISE	      EQU        (I2C2Base+0x20)
;IIC2 registers address
USART1Base         EQU        0x40013800
USART2Base         EQU        0x40004400
USART3Base         EQU        0x40004800
USART4Base         EQU        0x40004C00
USART5Base         EQU        0x40005000
;USART registers base address
USART1SR          EQU        (USART1Base+0x00)
USART1DR          EQU        (USART1Base+0x04)
USART1BRR         EQU        (USART1Base+0x08)
USART1CR1         EQU        (USART1Base+0x0C)
USART1CR2         EQU        (USART1Base+0x10)
USART1CR3         EQU        (USART1Base+0x14)
USART1GTPR        EQU        (USART1Base+0x18)
;USART1 registers address
USART2SR          EQU        (USART2Base+0x00)
USART2DR          EQU        (USART2Base+0x04)
USART2BRR         EQU        (USART2Base+0x08)
USART2CR1         EQU        (USART2Base+0x0C)
USART2CR2         EQU        (USART2Base+0x10)
USART2CR3         EQU        (USART2Base+0x14)
USART2GTPR        EQU        (USART2Base+0x18)
;USART2 registers address
USART3SR          EQU        (USART3Base+0x00)
USART3DR          EQU        (USART3Base+0x04)
USART3BRR         EQU        (USART3Base+0x08)
USART3CR1         EQU        (USART3Base+0x0C)
USART3CR2         EQU        (USART3Base+0x10)
USART3CR3         EQU        (USART3Base+0x14)
USART3GTPR        EQU        (USART3Base+0x18)
;USART3 registers address
USART4SR          EQU        (USART4Base+0x00)
USART4DR          EQU        (USART4Base+0x04)
USART4BRR         EQU        (USART4Base+0x08)
USART4CR1         EQU        (USART4Base+0x0C)
USART4CR2         EQU        (USART4Base+0x10)
USART4CR3         EQU        (USART4Base+0x14)
USART4GTPR        EQU        (USART4Base+0x18)
;USART4 registers address
USART5SR          EQU        (USART5Base+0x00)
USART5DR          EQU        (USART5Base+0x04)
USART5BRR         EQU        (USART5Base+0x08)
USART5CR1         EQU        (USART5Base+0x0C)
USART5CR2         EQU        (USART5Base+0x10)
USART5CR3         EQU        (USART5Base+0x14)
USART5GTPR        EQU        (USART5Base+0x18)
;USART5 registers address
IWDGBase          EQU        0x40003000
;Independent watchdog registers base address
IWDGKR            EQU        (IWDGBase+0x00)
IWDGPR            EQU        (IWDGBase+0x04)
IWDGRLR           EQU        (IWDGBase+0x08)
IWDGSR            EQU        (IWDGBase+0x0C)
;Independent watchdog registers address
WWDGBase          EQU        0x40002C00
;Window watchdog registers base address
WWDGCR            EQU        (WWDGBase+0x00)
WWDGCFR           EQU        (WWDGBase+0x04)
WWDGSR            EQU        (WWDGBase+0x08)
;Window watchdog registers address
RTCBase           EQU        0x40002800
;RTC registers base address
RTCCRH            EQU        (RTCBase+0x00)
RTCCRL            EQU        (RTCBase+0x04)
RTCPRLH           EQU        (RTCBase+0x08)
RTCPRLL           EQU        (RTCBase+0x0C)
RTCDIVH           EQU        (RTCBase+0x10)
RTCDIVL           EQU        (RTCBase+0x14)
RTCCNTH           EQU        (RTCBase+0x18)
RTCCNTL           EQU        (RTCBase+0x1C)
RTCALRH           EQU        (RTCBase+0x20)
RTCALRL           EQU        (RTCBase+0x24)
;RTC registers address
ADC1Base          EQU        0x40012400
ADC2Base          EQU        0x40012800
ADC3Base          EQU        0x40013C00
;ADC registers base address
ADC1SR            EQU        (ADC1Base+0x00)
ADC1CR1           EQU        (ADC1Base+0x04)
ADC1CR2           EQU        (ADC1Base+0x08)
ADC1SMPR1         EQU        (ADC1Base+0x0C)
ADC1SMPR2         EQU        (ADC1Base+0x10)
ADC1JOFR1         EQU        (ADC1Base+0x14)
ADC1JOFR2         EQU        (ADC1Base+0x18)
ADC1JOFR3         EQU        (ADC1Base+0x1C)
ADC1JOFR4         EQU        (ADC1Base+0x20)
ADC1HTR           EQU        (ADC1Base+0x24)
ADC1LTR           EQU        (ADC1Base+0x28)
ADC1SQR1          EQU        (ADC1Base+0x2C)
ADC1SQR2          EQU        (ADC1Base+0x30)
ADC1SQR3          EQU        (ADC1Base+0x34)
ADC1JSQR          EQU        (ADC1Base+0x38)
ADC1JDR1          EQU        (ADC1Base+0x3C)
ADC1JDR2          EQU        (ADC1Base+0x40)
ADC1JDR3          EQU        (ADC1Base+0x44)
ADC1JDR4          EQU        (ADC1Base+0x48)
ADC1DR            EQU        (ADC1Base+0x4C)
;ADC1 registers address
ADC2SR            EQU        (ADC2Base+0x00)
ADC2CR1           EQU        (ADC2Base+0x04)
ADC2CR2           EQU        (ADC2Base+0x08)
ADC2SMPR1         EQU        (ADC2Base+0x0C)
ADC2SMPR2         EQU        (ADC2Base+0x10)
ADC2JOFR1         EQU        (ADC2Base+0x14)
ADC2JOFR2         EQU        (ADC2Base+0x18)
ADC2JOFR3         EQU        (ADC2Base+0x1C)
ADC2JOFR4         EQU        (ADC2Base+0x20)
ADC2HTR           EQU        (ADC2Base+0x24)
ADC2LTR           EQU        (ADC2Base+0x28)
ADC2SQR1          EQU        (ADC2Base+0x2C)
ADC2SQR2          EQU        (ADC2Base+0x30)
ADC2SQR3          EQU        (ADC2Base+0x34)
ADC2JSQR          EQU        (ADC2Base+0x38)
ADC2JDR1          EQU        (ADC2Base+0x3C)
ADC2JDR2          EQU        (ADC2Base+0x40)
ADC2JDR3          EQU        (ADC2Base+0x44)
ADC2JDR4          EQU        (ADC2Base+0x48)
ADC2DR            EQU        (ADC2Base+0x4C)
;ADC2 registers address
ADC3SR            EQU        (ADC3Base+0x00)
ADC3CR1           EQU        (ADC3Base+0x04)
ADC3CR2           EQU        (ADC3Base+0x08)
ADC3SMPR1         EQU        (ADC3Base+0x0C)
ADC3SMPR2         EQU        (ADC3Base+0x10)
ADC3JOFR1         EQU        (ADC3Base+0x14)
ADC3JOFR2         EQU        (ADC3Base+0x18)
ADC3JOFR3         EQU        (ADC3Base+0x1C)
ADC3JOFR4         EQU        (ADC3Base+0x20)
ADC3HTR           EQU        (ADC3Base+0x24)
ADC3LTR           EQU        (ADC3Base+0x28)
ADC3SQR1          EQU        (ADC3Base+0x2C)
ADC3SQR2          EQU        (ADC3Base+0x30)
ADC3SQR3          EQU        (ADC3Base+0x34)
ADC3JSQR          EQU        (ADC3Base+0x38)
ADC3JDR1          EQU        (ADC3Base+0x3C)
ADC3JDR2          EQU        (ADC3Base+0x40)
ADC3JDR3          EQU        (ADC3Base+0x44)
ADC3JDR4          EQU        (ADC3Base+0x48)
ADC3DR            EQU        (ADC3Base+0x4C)
;ADC1 registers address
DACBase           EQU        0x40007400
;DAC registers base address
DACCR             EQU        (DACBase+0x00)
DACSWTRIGR        EQU        (DACBase+0x04)
DACDHR12R1        EQU        (DACBase+0x08)
DACDHR12L1        EQU        (DACBase+0x0C)
DACDHR8R1         EQU        (DACBase+0x10)
DACDHR12R2        EQU        (DACBase+0x14)
DACDHR12L2        EQU        (DACBase+0x18)
DACDHR8R2         EQU        (DACBase+0x1C)
DACDHR12RD        EQU        (DACBase+0x20)
DACDHR12LD        EQU        (DACBase+0x24)
DACDHR8RD         EQU        (DACBase+0x28)
DACDOR1           EQU        (DACBase+0x2C)
DACDOR2           EQU        (DACBase+0x30)
;DAC registers address
EXTIBase          EQU        0x40010400
;EXTI registers base address
EXTIIMR           EQU        (EXTIBase+0x00)
EXTIEMR           EQU        (EXTIBase+0x04)
EXTIRTSR          EQU        (EXTIBase+0x08)
EXTIFTSR          EQU        (EXTIBase+0x0C)
EXTISWIER         EQU        (EXTIBase+0x10)
EXTIPR            EQU        (EXTIBase+0x14)
;EXTI registers address
SCBBase           EQU        0xE000ED00
;SCB registers base address
SCBCPUID          EQU        (SCBBase+0x00)
SCBICSR           EQU        (SCBBase+0x40)
SCBVTOR           EQU        (SCBBase+0x08)
SCBAIRCR          EQU        (SCBBase+0x0C)
SCBSCR            EQU        (SCBBase+0x10)
SCBCCR            EQU        (SCBBase+0x14)
SCBSHPR1          EQU        (SCBBase+0x18)
SCBSHPR2          EQU	     (SCBBase+0x1C)
SCBSHPR3          EQU	     (SCBBase+0x20)
SCBSHCSR          EQU        (SCBBase+0x24)
SCBCFSR           EQU        (SCBBase+0x28)
SCBHFSR           EQU        (SCBBase+0x2C)
SCBMMAR           EQU        (SCBBase+0x34)
SCBBFAR           EQU        (SCBBase+0x38)
;SCB registers address
STKBase           EQU        0xE000E010
;SysTick registers base address
STKCTRL           EQU        (STKBase+0x00)
STKLOAD           EQU        (STKBase+0x04)
STKVAL            EQU        (STKBase+0x08)
STKCALIB          EQU        (STKBase+0x0C)
;SysTick registers address
NVICBase          EQU        0xE000E100
;NVIC Registers base address
NVICISER0         EQU        (NVICBase+0x000)
NVICISER1         EQU        (NVICBase+0x004)
NVICISER2         EQU        (NVICBase+0x008)
NVICICER0         EQU        (NVICBase+0x080)
NVICICER1         EQU        (NVICBase+0x084)
NVICICER2         EQU        (NVICBase+0x088)
NVICISPR0         EQU        (NVICBase+0x100)
NVICISPR1         EQU        (NVICBase+0x104)
NVICISPR2         EQU        (NVICBase+0x108)
NVICICPR0         EQU        (NVICBase+0x180)
NVICICPR1         EQU        (NVICBase+0x184)
NVICICPR2         EQU        (NVICBase+0x188)
NVICIABR0         EQU        (NVICBase+0x200)
NVICIABR1         EQU        (NVICBase+0x204)
NVICIABR2         EQU        (NVICBase+0x208)
NVICIPR0          EQU        (NVICBase+0x300)
NVICIPR1          EQU        (NVICBase+0x304)
NVICIPR2          EQU        (NVICBase+0x308)
NVICIPR3          EQU        (NVICBase+0x30C)
NVICIPR4          EQU        (NVICBase+0x310)
NVICIPR5          EQU        (NVICBase+0x314)
NVICIPR6          EQU        (NVICBase+0x318)
NVICIPR7          EQU        (NVICBase+0x31C)
NVICIPR8          EQU        (NVICBase+0x320)
NVICIPR9          EQU        (NVICBase+0x324)
NVICIPR10         EQU        (NVICBase+0x328)
NVICIPR11         EQU        (NVICBase+0x32C)
NVICIPR12         EQU        (NVICBase+0x330)
NVICIPR13         EQU        (NVICBase+0x334)
NVICIPR14         EQU        (NVICBase+0x338)
NVICIPR15         EQU        (NVICBase+0x33C)
NVICIPR16         EQU        (NVICBase+0x340)
NVICIPR17         EQU        (NVICBase+0x344)
NVICIPR18         EQU        (NVICBase+0x348)
NVICIPR19         EQU        (NVICBase+0x34C)
NVICIPR20         EQU        (NVICBase+0x350)
NVICSTIR          EQU        (NVICBase+0xE00)
;NVIC Registers address
MPUBase           EQU        0xE000ED90
;MPU Registers base address
MPUTYPER          EQU        (MPUBase+0x00)
MPUCR             EQU        (MPUBase+0x04)
MPURNR            EQU        (MPUBase+0x08)
MPURBAR           EQU        (MPUBase+0x0C)
MPURASR           EQU        (MPUBase+0x10)
MPURBARA1         EQU        (MPUBase+0x14)
MPURASRA1         EQU        (MPUBase+0x18)
MPURBARA2         EQU        (MPUBase+0x1C)
MPURASRA2         EQU        (MPUBase+0x20)
MPURBARA3         EQU        (MPUBase+0x1C)
MPURASRA3         EQU        (MPUBase+0x20)
;MPU Registers address
USBSRAM           EQU        0x40006000
CANSRAM           EQU        0x40006000
;Shared USB/CAN SRAM 512 bytes
                  END