	AREA    InitialValuePROC,CODE,READONLY

StartMessage		DCB   "System boot success! This project created by NULL.",0x0A
;Length of string"StartMessage": 0x33
VoltageMessage      DCB   "PA0 Voltage: 0000.0mV.",0x0A
;Length of string"VoltageMessage": 0x17
					ALIGN
						
LoadDataToRAM       PROC
	                EXPORT   LoadDataToRAM
					LDR      R0,=StartMessage
					LDR      R1,=0x20000000
;First string RAM base address.
					MOV      R2,#0x00
;Offset counter. Reset to 0.
					MOV      R3,#0x32 
;MAX offset address of the string.
Load1    			LDRB     R4,[R0,R2]
					CMP      R3,R2
					STRB     R4,[R1,R2]
					ADD      R2,#0x01
					BNE      Load1
;Load string from code memory to RAM.
					LDR      R0,=VoltageMessage
					ADD      R1,R2
;Get next string RAM base address.
					MOV      R2,#0x00
;Offset counter. Reset to 0.
					MOV      R3,#0x16
;MAX offset address of the string.
Load2    			LDRB     R4,[R0,R2]
                    CMP      R3,R2
					STRB     R4,[R1,R2]
					ADD      R2,#0x01
					BNE      Load2
;Load string from code memory to RAM
                    ADD      R1,R2
;Get next variable RAM base address.
                    MOV      R4,#0xFF
					STR      R4,[R1]
;Load initial value to variable.
                    ADD      R1,#0x04
;Get next variable RAM base address.
                    MOV      R4,#0x00
                    STR      R4,[R1]
;Load initial value to variable.
                    ADD      R1,#0x04
;Get next variable RAM base address.
                    STR      R4,[R1]
;Load initial value to variable.
	                BX       R14
					ALIGN
	                ENDP
                    END
						
;RAM Map:
;Heap start address: 0x20000000
;Head of the string "StartMessage": 0x20000000, length: 0x33
;Head of the string "VoltageMessage": 0x20000033, length: 0x17
;Address of the uint32 variable "LEDStatus": 0x2000004A
;Address of the uint32 variable "ADCCalibrationValue": 0x2000004E
;Address of the uint32 variable "AverageVoltageValue": 0x20000052
;No definition: 0x20000056-0x20000100
;Stack start address: 0x20000100-0x20000200