                    INCLUDE  Map.s
						
	AREA    LEDPROC,CODE,READONLY

DACInitialize       PROC
                    EXPORT   DACInitialize
					LDR      R0,=GPIOACRL
					LDR      R1,[R0]
					LDR      R2,=0xFF00FFFF
					AND      R2,R1
					STR      R2,[R0]
;Analog mode, Input mode. CNF5: 00, MODE5: 00, CNF4: 00, MODE4: 00.
					LDR      R0,=DACCR
					LDR      R1,=0x003D003D
					STR      R1,[R0]
;DAC channel1 enabled, DAC channel2 enabled, DAC channel1 trigger enable, DAC channel2 trigger enable.
;Software trigger, software trigger.
;EN1: 1, EN2: 1, TEN1: 1, TEN2: 1, TSEL1: 111, TSEL2: 111.
					BX       R14
					ENDP
DACStart            PROC
	                EXPORT   DACStart
					PUSH     {R0-R2}
					LDR      R0,=0x20000038
;Load PCM data base address.
					LDRH     R1,[R0]
					LDR      R2,=DACDHR12L1
					STR      R1,[R2]
;Write data to DAC_DHR1 register.
					LDRH     R1,[R0,#0x02]
					STR      R1,[R2,#0x0C]  ;DACDHR12L2
;Write data to DAC_DHR2 register.
					MOV      R1,#0x03
					STR      R1,[R2,#-0x08]  ;DACSWTRIGR
;Software trigger enabled, software trigger enabled.
;DAC_DHR1 register value will be loaded to the DAC_DOR1 register after this operation.
;SWTRIG1: 1, SWTRIG2: 1.
					POP      {R0-R2}
					BX       R14
					ENDP
					ALIGN
					END